component: DecisionFaults
proto_imports:
  - "vehicle/planner/diagnostics/decision_diagnostics.proto"
  - "vehicle/common/proto/traffic_lights.proto"
metric: zoox::diag::EmptyMetric
namespace: zoox::planner
faults:
  - id: 1
    name: FailedToComputeTrajectory
    severity: ERROR
    description: Trajectory is empty (has 0 segments)
    triggers_nogo: true
    deprecated: true
  - id: 2
    name: WaitingForDispatchCommand
    severity: INFO
    description: We are still waiting for a dispatch command
  - id: 3
    name: MalformedTrafficLightProto
    severity: ERROR
    description: Traffic light input proto is malformed
    freeze_frame: zoox.common.proto.JointStateProbabilityDistribution
    triggers_nogo: true
  - id: 4
    name: NoGoTriggered
    severity: ERROR
    description: There was a critical failure, see the freeze frame data.
    freeze_frame: zoox.planner.proto.NoGoTriggeredFreezeFrame
    triggers_nogo: true
    deprecated: true
  - id: 5
    name: NotOnMission
    severity: WARNING
    description: The vehicle is not close enough to the planned mission to safely engage autonomous.
    freeze_frame: zoox.planner.proto.NotOnMissionFreezeFrame
  - id: 6
    name: OutsideCorridor
    severity: ERROR
    description: Vehicle is outside of drivable decision corridor, not safe to engage autonomous.
    triggers_nogo: true
  - id: 7
    name: OutsideTrackingTolerance
    severity: ERROR
    description: Vehicle exceeds max tracking error
    triggers_nogo: true
    set_condition: The vehicle has too large a lateral error with respect to the current trajectory.
    clear_condition: The lateral error has gone below the required threshold; or, the vehicle exits autonomy.
    troubleshooting_steps: Contact the RMC team.
    signal: Derives from /planner/hero_state and /planner/decision. The /planner/tracker/debug lateral_error_m field performs a similar (but not identical) calculation.
    # Note that while this fault may indicate hardware issues, the most recent
    # occurrences of this appear to have been software related.
    requires_service: false
  - id: 8
    name: TrajectoryTooFarFromHero
    severity: ERROR
    description: Planned trajectory too far from hero state
    triggers_nogo: true
  - id: 9
    name: TrajectoryNotOnRoad
    severity: ERROR
    description: Decision trajectory is not on road
    triggers_nogo: true
  - id: 10
    name: InfeasibleAction
    severity: ERROR
    description: Action generator creates infeasible action reference
    freeze_frame: zoox.planner.proto.InfeasibleActionFreezeFrame
    triggers_nogo: true
  - id: 11
    name: OutsideCorridorAutonomous
    severity: WARNING
    description: Vehicle is outside of drivable decision corridor.
  - id: 12
    name: DuplicateOrBackwardTimestamp
    severity: WARNING
    description: Current timestamp is duplicate or backward.
  - id: 13
    name: PerceptionSensorInputNotNormal
    severity: ERROR
    description: Input from perception pipeline is not safe to engage autonomous.
    triggers_nogo: true
    deprecated: true
  - id: 14
    name: SearchFailure
    severity: ERROR
    description: Search failed to find a successful rollout.
    triggers_nogo: true
  - id: 15
    name: RouteDataTimeout
    severity: WARNING
    description: Timeout waiting for new route data from RouteDataGenerator.
  - id: 16
    name: NotUsingPerception
    severity: WARNING
    description: Decision planner is not using perception. Please check planner configuration and ensure the disabled setting is warranted.
  - id: 17
    name: FailedToPlanRoute
    severity: WARNING
    description: Unable to plan a route for the given mission
  - id: 18
    name: FailedToSetMission
    severity: WARNING
    description: Unable to set a new mission
    deprecated: true
  - id: 19
    name: FailedToCompleteDispatch
    severity: WARNING
    description: Unable to complete the current dispatch order
  - id: 20
    name: FailedToMatchAutonomousCtrlMode
    severity: ERROR
    description: Mismatch between requested and initial autonomous control mode.
    triggers_nogo: true
  - id: 21
    name: RoadGraphDataTimeout
    severity: WARNING
    description: Timeout waiting for new route data from RoadGraphSolver
  - id: 22
    name: RoadGraphDataBadMissionInput
    severity: ERROR
    description: Input message for RoadGraphSolver has bad mission input data
    triggers_nogo: true
  - id: 23
    name: FailedToReplanRouteWithoutLaneChange
    severity: WARNING
    description: Failed to replan to current destination when hero got stuck
  - id: 24
    name: StandstillSpeedViolation
    severity: ERROR
    description: Hero moved while it was operating in standstill mode
    triggers_nogo: true
  - id: 25
    name: CorridorCompatibilityViolation
    severity: ERROR
    description: Provided corridor is incompatible with Planner's current state
    triggers_nogo: true
  - id: 26
    name: RoadGraphDataFailedSemanticMapping
    severity: WARNING
    description: Semantic mapping for one or more mission waypoints failed in road graph solver
  - id: 27
    name: FailedToHardReplanRoute
    severity: WARNING
    description: Failed to replan to new destination during hard replanning
  - id: 28
    name: FailedToSoftReplanRoute
    severity: WARNING
    description: Failed to replan to new destination during soft replanning
  - id: 29
    name: HeroStartAndStillInJunction
    severity: WARNING
    description: Planner was started and remains within a junction.
  - id: 30
    name: HeroStartAndStillEstablishedInMultipleLanes
    severity: WARNING
    description: Planner was started and remains established in multiple lanes.
  - id: 31
    name: HeroStartAndStillInOncomingLane
    severity: WARNING
    description: Planner was started and remains in the oncoming lane.
  - id: 32
    name: HeroStartAndStillNoInlaneAction
    severity: WARNING
    description: Planner was started and remains missing an in-lane action.
  - id: 33
    name: UnmetActionReferenceGenerationExpectation
    severity: ERROR
    description: Generated action reference did not meet expectations.
    triggers_nogo: true
  - id: 34
    name: InconsistentActionReferenceInitialStates
    severity: ERROR
    description: Generated action reference initial states did not match.
    triggers_nogo: true
